> ## Documentation Index
> Fetch the complete documentation index at: https://developers.dwolla.com/llms.txt
> Use this file to discover all available pages before exploring further.

# List funding sources for an account

> Get a list of all funding sources associated with a specific Main Dwolla Account. This endpoint returns both bank accounts and balance funding sources, with detailed information about each funding source's status, type, and available processing channels.




## OpenAPI

````yaml get /accounts/{id}/funding-sources
openapi: 3.1.0
info:
  title: Dwolla API
  description: Dwolla API Documentation
  contact:
    name: Dwolla Developer Relations Team
    url: https://developers.dwolla.com
    email: api@dwolla.com
  version: '2.0'
  termsOfService: https://www.dwolla.com/legal/tos/
  license:
    name: MIT
    url: https://github.com/Dwolla/dwolla-openapi/blob/master/LICENSE
servers:
  - url: https://api.dwolla.com
    description: Production server
  - url: https://api-sandbox.dwolla.com
    description: Sandbox server
security:
  - clientCredentials: []
tags:
  - name: tokens
    description: Operations related to Application Access Tokens
  - name: root
    description: Root API operations
  - name: accounts
    description: Operations related to Accounts
  - name: customers
    description: Operations related to Customers
  - name: kba
    description: Operations related to Knowledge-Based Authentication
  - name: beneficial owners
    description: Operations related to Beneficial Owners
  - name: documents
    description: Operations related to Documents
  - name: exchanges
    description: Operations related to Exchanges
  - name: exchange sessions
    description: Operations related to Exchange Sessions
  - name: funding sources
    description: Operations related to Funding Sources
  - name: transfers
    description: Operations related to Transfers
  - name: labels
    description: Operations related to Labels
  - name: mass payments
    description: Operations related to Mass Payments
  - name: events
    description: Operations related to Events
  - name: webhook subscriptions
    description: Operations related to Webhook Subscriptions
  - name: webhooks
    description: Operations related to Webhooks
  - name: client tokens
    description: Operations related to Client Tokens
  - name: sandbox simulations
    description: Sandbox-only operations for simulating processing of bank transfers
paths:
  /accounts/{id}/funding-sources:
    get:
      tags:
        - accounts
      summary: List funding sources for an account
      description: >
        Get a list of all funding sources associated with a specific Main Dwolla
        Account. This endpoint returns both bank accounts and balance funding
        sources, with detailed information about each funding source's status,
        type, and available processing channels.
      operationId: listFundingSources
      parameters:
        - name: id
          in: path
          description: Account's unique identifier
          required: true
          schema:
            type: string
        - $ref: '#/components/parameters/Accept'
        - name: removed
          in: query
          description: Filter removed funding sources. Boolean value. Defaults to `true`
          required: false
          schema:
            type: string
      responses:
        '200':
          description: successful operation
          headers: {}
          content:
            application/vnd.dwolla.v1.hal+json:
              schema:
                $ref: '#/components/schemas/FundingSources'
        '403':
          description: forbidden
          headers: {}
          content:
            application/vnd.dwolla.v1.hal+json:
              schema:
                type: object
                properties:
                  code:
                    type: string
                    example: forbidden
                  message:
                    type: string
                    example: Not authorized to list funding sources.
        '404':
          description: not found
          headers: {}
          content:
            application/vnd.dwolla.v1.hal+json:
              schema:
                type: object
                properties:
                  code:
                    type: string
                    example: notFound
                  message:
                    type: string
                    example: Account not found.
      x-codeSamples:
        - lang: bash
          source: >
            GET
            https://api-sandbox.dwolla.com/accounts/CA366CA3-6D30-44D6-B0F3-8D86C64462A1/funding-sources

            Accept: application/vnd.dwolla.v1.hal+json

            Authorization: Bearer
            pBA9fVDBEyYZCEsLf/wKehyh1RTpzjUj5KzIRfDi0wKTii7DqY
        - lang: javascript
          source: |
            // Using dwolla-v2 - https://github.com/Dwolla/dwolla-v2-node
            dwolla
              .get("accounts/CA366CA3-6D30-44D6-B0F3-8D86C64462A1/funding-sources")
              .then((res) => res.body.total); // => 1
        - lang: python
          source: >
            # Using dwollav2 - https://github.com/Dwolla/dwolla-v2-python

            funding_sources =
            app_token.get('accounts/CA366CA3-6D30-44D6-B0F3-8D86C64462A1/funding-sources')

            funding_sources.body['total'] # => 1
        - lang: php
          source: >
            <?php

            // Using dwollaswagger -
            https://github.com/Dwolla/dwolla-swagger-php

            $fundingApi = new DwollaSwagger\FundingsourcesApi($apiClient);


            $fundingSources =
            $fundingApi->getAccountFundingSources("CA366CA3-6D30-44D6-B0F3-8D86C64462A1");

            $fundingSources->total; # => 1

            ?>
        - lang: ruby
          source: >
            # Using dwolla_v2 - https://github.com/Dwolla/dwolla-v2-ruby

            funding_sources = app_token.get
            "accounts/CA366CA3-6D30-44D6-B0F3-8D86C64462A1/funding-sources"

            funding_sources.total # => 1
components:
  parameters:
    Accept:
      name: Accept
      in: header
      required: true
      description: >-
        The media type of the response. Must be
        application/vnd.dwolla.v1.hal+json
      schema:
        type: string
        enum:
          - application/vnd.dwolla.v1.hal+json
        default: application/vnd.dwolla.v1.hal+json
  schemas:
    FundingSources:
      title: FundingSources
      type: object
      properties:
        _links:
          additionalProperties:
            $ref: '#/components/schemas/HalLink'
        _embedded:
          type: object
          properties:
            funding-sources:
              type: array
              items:
                $ref: '#/components/schemas/FundingSource'
        total:
          type: integer
          format: int32
          example: 3
    HalLink:
      title: HalLink
      type: object
      properties:
        href:
          type: string
          example: https://api.dwolla.com
        type:
          type: string
          example: application/vnd.dwolla.v1.hal+json
        resource-type:
          type: string
          example: resource-type
    FundingSource:
      title: FundingSource
      type: object
      properties:
        _links:
          additionalProperties:
            $ref: '#/components/schemas/HalLink'
        id:
          type: string
          example: d3d6b41e-5567-4bc6-9c6e-0efd0a3e647e
        status:
          type: string
          example: unverified
        type:
          type: string
          example: bank
        bankAccountType:
          type: string
          example: checking
        name:
          type: string
          example: My bank
        created:
          type: string
          format: date-time
          example: '2022-07-23T00:18:21.419Z'
        removed:
          type: boolean
          example: true
        channels:
          type: array
          description: Payment processing channels supported by this funding source
          items:
            type: string
            enum:
              - ach
              - real-time-payments
              - wire
              - external
            example: ach
        bankName:
          type: string
          example: SANDBOX TEST BANK
        fingerprint:
          type: string
          example: 5012989b55af15400e8102f95d2ec5e7ce3aef45c01613280d80a236dd8d6c
        bankUsageType:
          type: string
          description: >-
            The usage type of the bank account. Indicates if this is a
            settlement account for card network processors.
          enum:
            - card-network
          example: card-network
        cardDetails:
          type: object
          description: Card-specific details. Only present when type is 'card'.
          properties:
            brand:
              type: string
              description: >-
                The card brand/network (e.g., Visa, Mastercard, American
                Express)
              example: Visa
            lastFour:
              type: string
              description: The last four digits of the card number
              example: '1234'
            expirationMonth:
              type: integer
              description: The card expiration month (1-12)
              example: 12
              minimum: 1
              maximum: 12
            expirationYear:
              type: integer
              description: The card expiration year (4-digit year)
              example: 2026
            nameOnCard:
              type: string
              description: The cardholder name as it appears on the card
              example: John Doe
            bin:
              type: string
              description: >-
                Bank Identification Number (BIN) - the first 6-8 digits of the
                card number
              example: '40247644'
            billingAddress:
              type: object
              description: The billing address associated with the card
              properties:
                address1:
                  type: string
                  description: First line of the street address
                  example: 552 test
                address2:
                  type: string
                  description: Second line of the street address (optional)
                  example: Apt 4B
                address3:
                  type: string
                  description: Third line of the street address (optional)
                  example: Unit 101
                city:
                  type: string
                  description: City name
                  example: Des Moines
                stateProvinceRegion:
                  type: string
                  description: Two-letter state, province, or region code
                  example: IA
                country:
                  type: string
                  description: Two-letter country code (ISO 3166-1 alpha-2)
                  example: US
                postalCode:
                  type: string
                  description: Postal code or ZIP code
                  example: '50310'
  securitySchemes:
    clientCredentials:
      type: oauth2
      flows:
        clientCredentials:
          tokenUrl: /token
          x-speakeasy-token-endpoint-authentication: client_secret_basic
          scopes: {}

````